## biometryd 0.0.1+16.10.20160922.3

=== CMakeLists.txt ===
find_package(Qt5Core 5.4 REQUIRED)
find_package(Qt5Qml 5.4 REQUIRED)
find_package(Qt5Quick 5.4 REQUIRED)
find_package(Qt5QuickTest 5.4 REQUIRED)

configure_file(config.cpp.in config.cpp)
include_directories(.)
# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")

add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

# Ensure that we have a ready-made fixture maintaining a private bus instance
# readily available in unit- and integration tests.
add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE)

macro(BIOMETRYD_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src}
    ${CMAKE_CURRENT_SOURCE_DIR}/did_finish_successfully.h
    ${CMAKE_CURRENT_SOURCE_DIR}/echo_service.h
    ${CMAKE_CURRENT_SOURCE_DIR}/echo_service.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h
    ${CMAKE_CURRENT_BINARY_DIR}/config.cpp)

  target_link_libraries(
    ${test_name}

    biometry

    ${Boost_LIBRARIES}
    ${DBUS_CPP_LIBRARIES}
    ${PROCESS_CPP_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}

    ${ARGN}

    gmock

    gtest
    gtest_main)

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)
  set_tests_properties(${test_name} PROPERTIES ENVIRONMENT "BIOMETRYD_DBUS_SKELETON_IS_RUNNING_UNDER_TESTING=1")
endmacro(BIOMETRYD_ADD_TEST)

add_library(biometryd_devices_plugin_dl SHARED biometryd_devices_plugin_dl.cpp)
target_link_libraries(biometryd_devices_plugin_dl gtest gmock)

add_library(biometryd_devices_plugin_dl_version_mismatch SHARED biometryd_devices_plugin_dl_version_mismatch.cpp)
target_link_libraries(biometryd_devices_plugin_dl_version_mismatch gtest gmock)

BIOMETRYD_ADD_TEST(test_atomic_counter test_atomic_counter.cpp)
BIOMETRYD_ADD_TEST(test_configuration test_configuration.cpp)
BIOMETRYD_ADD_TEST(test_daemon test_daemon.cpp)
BIOMETRYD_ADD_TEST(test_device_registrar test_device_registrar.cpp)
BIOMETRYD_ADD_TEST(test_dispatching_device_and_service test_dispatching_service_and_device.cpp)
BIOMETRYD_ADD_TEST(test_dbus_codec test_dbus_codec.cpp)
BIOMETRYD_ADD_TEST(test_dbus_stub_skeleton test_dbus_stub_skeleton.cpp)
BIOMETRYD_ADD_TEST(test_dictionary test_dictionary.cpp)
BIOMETRYD_ADD_TEST(test_fingerprint_reader test_fingerprint_reader.cpp)
BIOMETRYD_ADD_TEST(test_forwarding test_forwarding.cpp)
BIOMETRYD_ADD_TEST(test_geometry test_geometry.cpp)
BIOMETRYD_ADD_TEST(test_operation test_operation.cpp)
BIOMETRYD_ADD_TEST(test_percent test_percent.cpp)
BIOMETRYD_ADD_TEST(test_plugin_device test_plugin_device.cpp)
BIOMETRYD_ADD_TEST(test_progress test_progress.cpp)
BIOMETRYD_ADD_TEST(test_user test_user.cpp)
BIOMETRYD_ADD_TEST(test_verifier test_verifier.cpp)

BIOMETRYD_ADD_TEST(test_cmds_config cmds/test_config.cpp)
BIOMETRYD_ADD_TEST(test_cmds_run cmds/test_run.cpp)
BIOMETRYD_ADD_TEST(test_cmds_test cmds/test_test.cpp)

if ("DEB_TARGET_ARCH" STREQUAL "powerpc")
else()
add_executable(test_qml_plugin test_qml_plugin.cpp)
qt5_use_modules(test_qml_plugin Core Qml Quick QuickTest)
add_test(test_qml_plugin test_qml_plugin)
set_tests_properties(test_qml_plugin PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal;QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/src/biometry/qml;BIOMETRYD_QML_ENABLE_TESTING=1")
file(GLOB BIOMETRYD_QML_TEST_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} tst_*.qml)

foreach (QML_FILE ${BIOMETRYD_QML_TEST_FILES})
    message(INFO  ${QML_FILE})
    configure_file(${QML_FILE} ${QML_FILE} COPYONLY)
  endforeach(QML_FILE)
endif()

=== biometry/CMakeLists.txt ===
file(GLOB_RECURSE BIOMETRYD_PUBLIC_HEADERS ${CMAKE_SOURCE_DIR}/include/*.h)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")

add_subdirectory(qml)

configure_file(daemon_configuration.cpp.in daemon_configuration.cpp)

add_library(
  biometry SHARED

  application.cpp
  daemon.h
  daemon.cpp  
  device_registrar.h
  device_registrar.cpp
  device_registry.h
  device_registry.cpp
  dispatching_service.h
  dispatching_service.cpp
  geometry.cpp
  percent.cpp
  progress.cpp
  reason.cpp
  runtime.h
  runtime.cpp
  tracing_operation_observer.h
  user.cpp
  variant.cpp
  version.cpp
  
  "${CMAKE_CURRENT_BINARY_DIR}/daemon_configuration.cpp"

  cmds/config.h
  cmds/config.cpp
  cmds/enroll.h
  cmds/enroll.cpp
  cmds/identify.h
  cmds/identify.cpp
  cmds/list_devices.h
  cmds/list_devices.cpp
  cmds/run.h
  cmds/run.cpp
  cmds/test.h
  cmds/test.cpp
  cmds/version.h
  cmds/version.cpp

  dbus/codec.h
  dbus/interface.h
  dbus/service.cpp
  dbus/stub/service.h
  dbus/stub/service.cpp
  dbus/stub/device.h
  dbus/stub/device.cpp
  dbus/stub/template_store.h
  dbus/stub/template_store.cpp
  dbus/stub/identifier.h
  dbus/stub/identifier.cpp
  dbus/stub/observer.h
  dbus/stub/operation.h

  dbus/skeleton/credentials_resolver.h
  dbus/skeleton/daemon_credentials_resolver.h
  dbus/skeleton/daemon_credentials_resolver.cpp
  dbus/skeleton/request_verifier.h
  dbus/skeleton/request_verifier.cpp
  dbus/skeleton/service.h
  dbus/skeleton/service.cpp
  dbus/skeleton/device.h
  dbus/skeleton/device.cpp
  dbus/skeleton/template_store.h
  dbus/skeleton/template_store.cpp
  dbus/skeleton/identifier.h
  dbus/skeleton/identifier.cpp
  dbus/skeleton/observer.h
  dbus/skeleton/operation.h

  devices/dispatching.h
  devices/dispatching.cpp
  devices/dummy.h
  devices/dummy.cpp
  devices/fingerprint_reader.cpp
  devices/forwarding.h
  devices/forwarding.cpp

  devices/plugin/device.h
  devices/plugin/device.cpp
  devices/plugin/enumerator.h
  devices/plugin/enumerator.cpp
  devices/plugin/loader.h
  devices/plugin/loader.cpp
  devices/plugin/verifier.h
  devices/plugin/verifier.cpp

  util/atomic_counter.h
  util/atomic_counter.cpp
  util/benchmark.h
  util/benchmark.cpp
  util/cli.h
  util/cli.cpp
  util/configuration.h
  util/configuration.cpp
  util/dispatcher.h
  util/dispatcher.cpp
  util/dynamic_library.h
  util/dynamic_library.cpp
  util/json_configuration_builder.h
  util/json_configuration_builder.cpp
  util/not_implemented.h
  util/not_implemented.cpp
  util/not_reachable.h
  util/not_reachable.cpp
  util/once.h
  util/property_store.h
  util/property_store.cpp
  util/statistics.h
  util/statistics.cpp
  util/streaming_configuration_builder.h
  util/synchronized.h

  ${BIOMETRYD_PUBLIC_HEADERS})

set_target_properties(
  biometry

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${BIOMETRYD_VERSION_MAJOR}.${BIOMETRYD_VERSION_MINOR}.${BIOMETRYD_VERSION_PATCH}
  SOVERSION ${BIOMETRYD_VERSION_MAJOR}
)

target_link_libraries(
  biometry

  util

  dl
  elf

  ${Boost_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${PROCESS_CPP_LIBRARIES}
  ${SQLITE3_LIBRARIES})

add_executable(
  biometryd
  daemon_main.cpp)

target_link_libraries(
  biometryd

  biometry)

install(
  TARGETS biometry
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  TARGETS biometryd
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== biometry/qml/Biometryd/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fPIC -fvisibility=hidden -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -Werror -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -pthread")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

find_package(Qt5Core 5.4 REQUIRED)
find_package(Qt5Qml 5.4 REQUIRED)
find_package(Qt5Quick 5.4 REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_library(
    biometryd-qml SHARED

    device.h
    device.cpp
    converter.h
    converter.cpp
    fingerprint_reader.h
    fingerprint_reader.cpp
    identifier.h
    identifier.cpp
    operation.h
    operation.cpp
    service.h
    service.cpp
    template_store.h
    template_store.cpp
    user.h
    user.cpp

    plugin.h
    plugin.cpp)

qt5_use_modules(biometryd-qml Core Qml Quick)
target_link_libraries(biometryd-qml biometry)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    COMMAND qmlplugindump -notrelocatable Biometryd 0.0 ../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    DEPENDS biometryd-qml
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

# We make the module available to qml tests without
# requiring installation of the module. With that, we
# can test the module within the build env.
configure_file(qmldir qmldir COPYONLY)

set(PLUGIN_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/qml/Biometryd)

install(
    TARGETS biometryd-qml
    DESTINATION ${PLUGIN_DIR})

install(
    FILES qmldir
    DESTINATION ${PLUGIN_DIR})

add_custom_target(
    Content_generated_files ALL
    SOURCES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    DESTINATION ${PLUGIN_DIR})

## biometryd 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(biometryd)

set(PROJECT_VERSION 0.3.0)

set(BIOMETRYD_VERSION_MAJOR 1)
set(BIOMETRYD_VERSION_MINOR 0)
set(BIOMETRYD_VERSION_PATCH 1)

option(ENABLE_WERROR "Treat all build warnings as errors" ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC -fvisibility=hidden -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra -fPIC -pthread -DBOOST_ASIO_DISABLE_EPOLL")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

if(ENABLE_WERROR)
    add_compile_options("-Werror")
endif()

include(GNUInstallDirs)

set(
    BIOMETRYD_DEFAULT_PLUGIN_DIRECTORY "${CMAKE_INSTALL_FULL_LIBDIR}/biometryd/plugins"
    CACHE STRING "Default plugin installation directory")

set(
    BIOMETRYD_CUSTOM_PLUGIN_DIRECTORY "/custom/vendor/biometryd/plugins"
    CACHE STRING "Custom plugin installation directory")

enable_testing()

find_package(PkgConfig)
find_package(Boost COMPONENTS filesystem program_options system REQUIRED)

pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(SQLITE3 sqlite3 REQUIRED)

# Opt-in to enable hybris support
option(WITH_HYBRIS "Enable libhybris integration support" OFF)
if (WITH_HYBRIS)
    # Try to find hybris, and disable hybris from build if not found
    find_library(Hybris
        NAMES hybris-common REQUIRED
    )
endif()

include_directories(
    include
    src

    # Make sure that files generated during build are available for compilation.
    # Most notably, this refers to include/biometry/version.h
    ${CMAKE_BINARY_DIR}/include

    ${Boost_INCLUDE_DIRS}
    ${DBUS_CPP_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${LIBAPPARMOR_INCLUDE_DIRS}
    ${PROCESS_CPP_INCLUDE_DIRS}
    ${SQLITE3_INCLUDE_DIRS})

add_subdirectory(data)
add_subdirectory(doc)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tests)

=== data/CMakeLists.txt ===
configure_file(
  biometryd.pc.in biometryd.pc @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  )

install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.ubports.biometryd.Service.conf
  DESTINATION /etc/dbus-1/system.d/
)

install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/biometryd.conf
  DESTINATION /etc/init
)


install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/biometryd.service
  DESTINATION /lib/systemd/system/
)

=== tests/CMakeLists.txt ===
find_package(Qt5Core 5.4 REQUIRED)
find_package(Qt5Qml 5.4 REQUIRED)
find_package(Qt5Quick 5.4 REQUIRED)
find_package(Qt5QuickTest 5.4 REQUIRED)

configure_file(config.cpp.in config.cpp)

set(GMOCK_BUILD_SHARED_LIBS ON)
find_package(GMock)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GMOCK_INCLUDE_DIRS}
)

# Ensure that we have a ready-made fixture maintaining a private bus instance
# readily available in unit- and integration tests.
add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE)

macro(BIOMETRYD_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src}
    ${CMAKE_CURRENT_SOURCE_DIR}/did_finish_successfully.h
    ${CMAKE_CURRENT_SOURCE_DIR}/echo_service.h
    ${CMAKE_CURRENT_SOURCE_DIR}/echo_service.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h
    ${CMAKE_CURRENT_BINARY_DIR}/config.cpp)

  target_link_libraries(
    ${test_name}

    biometry

    ${Boost_LIBRARIES}
    ${DBUS_CPP_LIBRARIES}
    ${PROCESS_CPP_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}

    ${ARGN}

    ${GMOCK_LIBRARIES})

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)
  set_tests_properties(${test_name} PROPERTIES ENVIRONMENT "BIOMETRYD_DBUS_SKELETON_IS_RUNNING_UNDER_TESTING=1")
endmacro(BIOMETRYD_ADD_TEST)

add_library(biometryd_devices_plugin_dl SHARED biometryd_devices_plugin_dl.cpp)
target_link_libraries(biometryd_devices_plugin_dl gtest gmock)

add_library(biometryd_devices_plugin_dl_version_mismatch SHARED biometryd_devices_plugin_dl_version_mismatch.cpp)
target_link_libraries(biometryd_devices_plugin_dl_version_mismatch gtest gmock)

BIOMETRYD_ADD_TEST(test_atomic_counter test_atomic_counter.cpp)
BIOMETRYD_ADD_TEST(test_configuration test_configuration.cpp)
BIOMETRYD_ADD_TEST(test_daemon test_daemon.cpp)
BIOMETRYD_ADD_TEST(test_device_registrar test_device_registrar.cpp)
BIOMETRYD_ADD_TEST(test_dispatching_device_and_service test_dispatching_service_and_device.cpp)
BIOMETRYD_ADD_TEST(test_dbus_codec test_dbus_codec.cpp)
BIOMETRYD_ADD_TEST(test_dbus_stub_skeleton test_dbus_stub_skeleton.cpp)
BIOMETRYD_ADD_TEST(test_dictionary test_dictionary.cpp)
BIOMETRYD_ADD_TEST(test_fingerprint_reader test_fingerprint_reader.cpp)
BIOMETRYD_ADD_TEST(test_forwarding test_forwarding.cpp)
BIOMETRYD_ADD_TEST(test_geometry test_geometry.cpp)
BIOMETRYD_ADD_TEST(test_operation test_operation.cpp)
BIOMETRYD_ADD_TEST(test_percent test_percent.cpp)
BIOMETRYD_ADD_TEST(test_plugin_device test_plugin_device.cpp)
BIOMETRYD_ADD_TEST(test_progress test_progress.cpp)
BIOMETRYD_ADD_TEST(test_user test_user.cpp)

# TODO implement verifier test, its currently empty
#BIOMETRYD_ADD_TEST(test_verifier test_verifier.cpp)

BIOMETRYD_ADD_TEST(test_cmds_config cmds/test_config.cpp)
BIOMETRYD_ADD_TEST(test_cmds_run cmds/test_run.cpp)
BIOMETRYD_ADD_TEST(test_cmds_test cmds/test_test.cpp)

if ("DEB_TARGET_ARCH" STREQUAL "powerpc")
else()
add_executable(test_qml_plugin test_qml_plugin.cpp)
qt5_use_modules(test_qml_plugin Core Qml Quick QuickTest)
add_test(test_qml_plugin test_qml_plugin)
set_tests_properties(test_qml_plugin PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal;QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/src/biometry/qml;BIOMETRYD_QML_ENABLE_TESTING=1")
file(GLOB BIOMETRYD_QML_TEST_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} tst_*.qml)

foreach (QML_FILE ${BIOMETRYD_QML_TEST_FILES})
    message(INFO  ${QML_FILE})
    configure_file(${QML_FILE} ${QML_FILE} COPYONLY)
  endforeach(QML_FILE)
endif()

=== include/biometry/CMakeLists.txt ===
configure_file(version.h.in version.h)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/version.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/biometry
)

add_subdirectory(hardware)

=== src/biometry/CMakeLists.txt ===
file(GLOB_RECURSE BIOMETRYD_PUBLIC_HEADERS ${CMAKE_SOURCE_DIR}/include/*.h)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")

add_subdirectory(qml)

configure_file(daemon_configuration.cpp.in daemon_configuration.cpp)

if(WITH_HYBRIS)
  set(HYBRIS_SRC
    devices/android.h
    devices/android.cpp

    hardware/biometry_fp_api.cpp
    hardware/android_hw_module.h
  )

  add_definitions(-DWITH_HYBRIS)
endif()

add_library(
  biometry SHARED

  application.cpp
  daemon.h
  daemon.cpp
  device_registrar.h
  device_registrar.cpp
  device_registry.h
  device_registry.cpp
  dispatching_service.h
  dispatching_service.cpp
  geometry.cpp
  percent.cpp
  progress.cpp
  reason.cpp
  runtime.h
  runtime.cpp
  tracing_operation_observer.h
  user.cpp
  variant.cpp
  version.cpp

  "${CMAKE_CURRENT_BINARY_DIR}/daemon_configuration.cpp"

  cmds/config.h
  cmds/config.cpp
  cmds/enroll.h
  cmds/enroll.cpp
  cmds/identify.h
  cmds/identify.cpp
  cmds/list_devices.h
  cmds/list_devices.cpp
  cmds/run.h
  cmds/run.cpp
  cmds/test.h
  cmds/test.cpp
  cmds/version.h
  cmds/version.cpp

  dbus/codec.h
  dbus/interface.h
  dbus/service.cpp
  dbus/stub/service.h
  dbus/stub/service.cpp
  dbus/stub/device.h
  dbus/stub/device.cpp
  dbus/stub/template_store.h
  dbus/stub/template_store.cpp
  dbus/stub/identifier.h
  dbus/stub/identifier.cpp
  dbus/stub/observer.h
  dbus/stub/operation.h

  dbus/skeleton/credentials_resolver.h
  dbus/skeleton/daemon_credentials_resolver.h
  dbus/skeleton/daemon_credentials_resolver.cpp
  dbus/skeleton/request_verifier.h
  dbus/skeleton/request_verifier.cpp
  dbus/skeleton/service.h
  dbus/skeleton/service.cpp
  dbus/skeleton/device.h
  dbus/skeleton/device.cpp
  dbus/skeleton/template_store.h
  dbus/skeleton/template_store.cpp
  dbus/skeleton/identifier.h
  dbus/skeleton/identifier.cpp
  dbus/skeleton/observer.h
  dbus/skeleton/operation.h

  devices/dispatching.h
  devices/dispatching.cpp
  devices/dummy.h
  devices/dummy.cpp
  devices/fingerprint_reader.cpp
  devices/forwarding.h
  devices/forwarding.cpp

  devices/plugin/device.h
  devices/plugin/device.cpp
  devices/plugin/enumerator.h
  devices/plugin/enumerator.cpp
  devices/plugin/loader.h
  devices/plugin/loader.cpp
  devices/plugin/verifier.h
  devices/plugin/verifier.cpp

  util/atomic_counter.h
  util/atomic_counter.cpp
  util/benchmark.h
  util/benchmark.cpp
  util/cli.h
  util/cli.cpp
  util/configuration.h
  util/configuration.cpp
  util/dispatcher.h
  util/dispatcher.cpp
  util/dynamic_library.h
  util/dynamic_library.cpp
  util/json_configuration_builder.h
  util/json_configuration_builder.cpp
  util/not_implemented.h
  util/not_implemented.cpp
  util/not_reachable.h
  util/not_reachable.cpp
  util/once.h
  util/property_store.h
  util/property_store.cpp
  util/statistics.h
  util/statistics.cpp
  util/streaming_configuration_builder.h
  util/synchronized.h

  bridge/bridge_defs.h
  bridge/bridge.h
  bridge/hybris_bridge_defs.h

  ${HYBRIS_SRC}

  ${BIOMETRYD_PUBLIC_HEADERS})

set_target_properties(
  biometry

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${BIOMETRYD_VERSION_MAJOR}.${BIOMETRYD_VERSION_MINOR}.${BIOMETRYD_VERSION_PATCH}
  SOVERSION ${BIOMETRYD_VERSION_MAJOR}
)

target_link_libraries(
  biometry

  util

  dl
  elf

  ${Boost_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${PROCESS_CPP_LIBRARIES}
  ${SQLITE3_LIBRARIES}
  ${Hybris})

add_executable(
  biometryd
  daemon_main.cpp)

target_link_libraries(
  biometryd

  biometry)

install(
  TARGETS biometry
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  TARGETS biometryd
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== include/biometry/hardware/CMakeLists.txt ===
set(
  BIOMETRY_HARDWARE_HEADERS
  biometry.h
)

install(
  FILES ${BIOMETRY_HARDWARE_HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/biometry/hardware
)

=== src/biometry/qml/Biometryd/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC -fvisibility=hidden -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -pthread")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

if(ENABLE_WERROR)
    add_compile_options("-Werror")
endif()

find_package(Qt5Core 5.4 REQUIRED)
find_package(Qt5Qml 5.4 REQUIRED)
find_package(Qt5Quick 5.4 REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_library(
    biometryd-qml SHARED

    device.h
    device.cpp
    converter.h
    converter.cpp
    fingerprint_reader.h
    fingerprint_reader.cpp
    identifier.h
    identifier.cpp
    operation.h
    operation.cpp
    service.h
    service.cpp
    template_store.h
    template_store.cpp
    user.h
    user.cpp

    plugin.h
    plugin.cpp)

qt5_use_modules(biometryd-qml Core Qml Quick)
target_link_libraries(biometryd-qml biometry)

# We make the module available to qml tests without
# requiring installation of the module. With that, we
# can test the module within the build env.
configure_file(qmldir qmldir COPYONLY)

set(PLUGIN_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/qml/Biometryd)

install(
    TARGETS biometryd-qml
    DESTINATION ${PLUGIN_DIR})

install(
    FILES qmldir
    DESTINATION ${PLUGIN_DIR})

if (NOT CMAKE_CROSSCOMPILING)
    add_custom_target(
        Content_generated_files ALL
        SOURCES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes)

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
        COMMAND qmlplugindump -notrelocatable Biometryd 0.0 ../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
        DEPENDS biometryd-qml
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
        DESTINATION ${PLUGIN_DIR})
endif()

=== debian/changelog ===
biometryd (0.3.0-2) unstable; urgency=medium

  * Upload 0.3.0 was flawed, it did not contain already uploaded
    src:pkg version 0.0.3~git20230110.a8818c2-1. This upload amends this.
  * debian/rules:
    + Re-enable unit tests.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 30 Jan 2023 23:31:10 +0100

biometryd (0.3.0-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * New upstream release.
  * debian/watch:
    + Start watching upstream releases.
  * debian/patches:
    + Drop 1001_CMake-Werror-option.patch. Applied upstream.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/copyright:
    + Update copyright attributions for debian/.
  * debian/rules:
    + Disable unit tests for now, they freeze endlessly in this upstream
      release.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 30 Jan 2023 22:41:39 +0100

biometryd (0.0.3~git20230110.a8818c2-1) unstable; urgency=medium

  * New git snapshot 0.0.3~git20230110.a8818c2
  * [debian/patches] Drop upstreamed patch
    + 1001_CMake-Werror-option.patch
  * [debian/rules] Specifically disable lto due to dlopen issue
  * [debian/rules] Disable hybris build
  * [debian/patches] Disable one flaky test

 -- Marius Gripsgard <marius@ubports.com>  Tue, 10 Jan 2023 23:34:26 +0100

biometryd (0.0.3~git20221003.39b529a-3) unstable; urgency=medium

  * Team upload.
  * d/patches/3000_disable_test_qml_plugin.patch
    + disable test_qml_plugin.

 -- Anton Gladky <gladk@debian.org>  Fri, 21 Oct 2022 10:14:45 +0200

biometryd (0.0.3~git20221003.39b529a-2) unstable; urgency=medium

  * Team upload.
  * libbiometry1.symbols
    + Add symbols to fix FTBFS on some platforms.

 -- Anton Gladky <gladk@debian.org>  Thu, 20 Oct 2022 18:54:46 +0200

biometryd (0.0.3~git20221003.39b529a-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1021212, #1019365).

  * debian/patches/:
    + Add 1001_CMake-Werror-option.patch.
    + Add 2001_no-lxc-android-config-service-in-Debian.patch. Don't want
      lxc-android-config.service. We don't/won't have that in Debian, for now.
  * debian/:
    + Rename libbiometryd* pkgs to libbiometry* and make lib:pkg and dev:pkg
      match the library's SONAME.
  * debian/{control,compat}:
    + Switch to debhelper-compat notation, bump to DH compat level version 13.
  * debian/control:
    + Drop top comment. Not true for biometryd in Debian: the control
      file does not get auto-generated (any more).
    + Bump Standards-Version: to 4.6.1. No changes needed.
    + Drop from B-D: qt5-default.
    + Adjust Vcs-*: fields for Debian.
    + Update Maintainer: field for official Debian upload. Add Uploaders: field.
    + Add Rules-Requires-Root: field and set it to 'no'.
    + Line-wrap too-long extended descriptions.
    + Make biometryd-bin multi-arch: foreign.
    + Disentangle circular dependency between biometryd-bin <-> libbiometryd1.
    + Add B-D: pkg-kde-tools.
  * debian/{control,copyright}:
    + Update homepage URL.
  * debian/rules:
    + Adapt to building with DH compat level 13.
    + Add get-orig-source target.
    + Build with -DENABLE_WERROR=OFF.
    + Amend broken install target for include/biometryd/.
    + Enable all hardening flags.
    + Build with pkgkde_symbolshelper.
    + Don't run tests in parallel.
  * debian/{rules,biometryd-bin.install}:
    + Don't install upstart configuration.
  * debian/watch:
    + Add file. Obtain upstream Git snapshot for now.
  * debian/source/format:
    + Add file. Use format '3.0 (quilt)'.
  * debian/biometryd-bin.install:
    + Also install systemd files.
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/copyright:
    + Use secure copyright format URL.
  * debian/libbiometry1.symbols:
    + Add .symbols file.
  * debian/copyright:
    + Add auto-generated copyright.in file for later reference to copyright
      updates.
    + Adjust copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 04 Oct 2022 01:05:53 +0200

biometryd (0.0.2+ubports1) xenial; urgency=medium

  * No change rebuild to publish sources to ubports repo

 -- Dan Chapman <dan@ubports.com>  Tue, 20 Feb 2018 09:33:23 +0000

biometryd (0.0.2+ubports) xenial; urgency=medium

  * Imported to UBports

 -- UBports auto importer <infra@ubports.com>  Sun, 07 Jan 2018 06:48:46 +0000

biometryd (0.0.1+17.04.20170406.2-0ubuntu1) zesty; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * Switch to using cmake-extras for gmock and gtest. (LP: #1680153)

 -- Łukasz Zemczak <lukasz.zemczak@canonical.com>  Thu, 06 Apr 2017 16:41:56 +0000

biometryd (0.0.1+16.10.20160922.3-0ubuntu1) yakkety; urgency=medium

  * Added shlibs:Depends

 -- Ken VanDine <ken.vandine@canonical.com>  Thu, 22 Sep 2016 19:42:16 +0000

biometryd (0.0.1+16.10.20160628-0ubuntu4) yakkety; urgency=medium

  * Skip qml test on powerpc, segfaults. LP: #1606927

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 18 Aug 2016 15:44:55 +0100

biometryd (0.0.1+16.10.20160628-0ubuntu3) yakkety; urgency=medium

  * Cast enum to int, to use in another enum. Fixes FTBFS with gcc6.
  * Rebuild for boost soname change.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 18 Aug 2016 11:13:07 +0100

biometryd (0.0.1+16.10.20160628-0ubuntu2) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:11:16 +0000

biometryd (0.0.1+16.10.20160628-0ubuntu1) yakkety; urgency=medium

  * Add an initial snapcraft.yaml setup for biometryd.
  * Add sphinx documentation.

 -- Thomas Voß <thomas.voss@canonical.com>  Tue, 28 Jun 2016 06:20:19 +0000

biometryd (0.0.1+16.10.20160627.2-0ubuntu1) yakkety; urgency=medium

  * If default device cannot be instantiated, exit cleanly with success
    to prevent respawn watchdog from triggering.

 -- Thomas Voß <thomas.voss@canonical.com>  Mon, 27 Jun 2016 13:59:40 +0000

biometryd (0.0.1+16.10.20160621.1-0ubuntu1) yakkety; urgency=medium

  [ Thomas Voß ]
  * Initial release.


=== debian/control ===
Source: biometryd
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               debhelper-compat (= 13),
               doxygen,
               google-mock,
               graphviz,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-test-dev,
               libdbus-cpp-dev (>= 4.0.0),
               libdbus-1-dev,
               libelf-dev,
               libgtest-dev,
               libprocess-cpp-dev,
               libsqlite3-dev,
               lsb-release,
               pkg-config,
               qml-module-qttest,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               pkg-kde-tools,
Standards-Version: 4.6.2
Section: libs
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/biometryd/
Vcs-Git: https://salsa.debian.org/ubports-team/biometryd.git
Vcs-Browser: https://salsa.debian.org/ubports-team/biometryd

Package: libbiometry1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: libbiometryd1 (<< 0.0.3~),
Replaces: libiometryd1 (<< 0.0.3~),
Recommends: biometryd-bin,
Description: biometryd mediates/multiplexes to biometric devices - runtime library
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 This package includes the biometryd runtime libraries.

Package: libbiometry-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbiometry1 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libbiometryd-dev (<< 0.0.3~),
Replaces: libiometryd-dev (<< 0.0.3~),
Description: biometryd mediates/multiplexes to biometric devices - development headers
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 This package includes all the development headers and libraries for
 biometryd.

Package: biometryd-bin
Section: devel
Architecture: any
Multi-Arch: foreign
Depends: libbiometry1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: biometryd mediates/multiplexes to biometric devices - daemon/helper binaries
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 Daemon and helper binaries to be used by services.

Package: qml-module-biometryd
Section: devel
Architecture: any
Depends: libbiometry1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: biometryd mediates/multiplexes to biometric devices - QML bindings
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 This package contains the qtdeclarative bindings for biometryd.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# We cannot use lto due to biometryds plugin system will fail
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
include /usr/share/dpkg/default.mk

# The home directory of user buildd does not exist on the builders
export XDG_DATA_HOME=/tmp

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	# DEB_TARGET_ARCH is to avoid running qml tests on powerpc
	dh_auto_configure -- -DDEB_TARGET_ARCH=$(DEB_TARGET_ARCH)	\
	                     -DENABLE_WERROR=OFF			\
	                     -DWITH_HYBRIS=OFF				\
	                     $(NULL)

override_dh_install:
	# drop upstart configuration
	rm -Rv debian/tmp/etc/init/

	# Nasty CMakeLists.txt appearing in include directory
	# See: https://gitlab.com/ubports/development/core/biometryd/-/issues/2
	rm -v  debian/tmp/usr/include/biometry/CMakeLists.txt
	dh_install

override_dh_auto_test:
	# we have seen test failures when building with 8 cores instead of 4
	dh_auto_test --no-parallel

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/biometryd/tags .*/biometryd-(\d\S+)\.tar\.gz

## biometryd 0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(biometryd)
 
-set(PROJECT_VERSION 0.3.0)
+set(PROJECT_VERSION 0.3.1)
 
 set(BIOMETRYD_VERSION_MAJOR 1)
 set(BIOMETRYD_VERSION_MINOR 0)
@@ -39,6 +39,15 @@
 pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
 pkg_check_modules(SQLITE3 sqlite3 REQUIRED)
 
+# Opt-out of depending on systemd at build-time
+option(USE_SYSTEMD "Install systemd service" ON)
+if (USE_SYSTEMD)
+    pkg_check_modules(SYSTEMD systemd)
+    if (NOT SYSTEMD_FOUND)
+        message(FATAL_ERROR "systemd pkg-config not found (required for figuring out service install location)")
+    endif()
+endif()
+
 # Opt-in to enable hybris support
 option(WITH_HYBRIS "Enable libhybris integration support" OFF)
 if (WITH_HYBRIS)

=== data/CMakeLists.txt ===
configure_file(
  biometryd.conf.in biometryd.conf @ONLY
)
configure_file(
  biometryd.pc.in biometryd.pc @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  )

install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.ubports.biometryd.Service.conf
  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.conf
  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/init
)

if (USE_SYSTEMD)
    pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemdsystemunitdir)

    configure_file(
      biometryd.service.in biometryd.service @ONLY
    )

    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.service
      DESTINATION ${SYSTEMD_SYSTEM_UNIT_DIR}
    )
endif()

=== doc/CMakeLists.txt ===
option(
  BIOMETRYD_ENABLE_DOC_GENERATION
  "Generate package documentation with doxygen"
  OFF
)

if (BIOMETRYD_ENABLE_DOC_GENERATION)

# Please note that we are creating documentation within the source tree
# as we are hosting our documentation on readthedocs.org. For their build machinery to work
# properly, we need to generate doxygen XML output within the source tree.
  
find_package(Doxygen)

if (DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in 
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION ${CMAKE_INSTALL_DOCDIR})

endif ()
endif ()

=== include/CMakeLists.txt ===
add_subdirectory(biometry)

install(
  DIRECTORY biometry
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/biometry/qml/Biometryd/CMakeLists.txt ===
--- 
+++ 
@@ -36,8 +36,7 @@
     plugin.h
     plugin.cpp)
 
-qt5_use_modules(biometryd-qml Core Qml Quick)
-target_link_libraries(biometryd-qml biometry)
+target_link_libraries(biometryd-qml biometry Qt5::Core Qt5::Qml Qt5::Quick)
 
 # We make the module available to qml tests without
 # requiring installation of the module. With that, we

=== debian/changelog ===
biometryd (0.3.1-3build4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:16:36 +0000

biometryd (0.3.1-3build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:43:30 +0000

biometryd (0.3.1-3build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 03:57:59 +0000

biometryd (0.3.1-3build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 00:56:49 +0000

biometryd (0.3.1-3) unstable; urgency=medium

  * debian/control:
    + Switch from systemd to systemd-dev in B-D (and limit it to [linux-any]).

 -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Fri, 02 Feb 2024 12:33:45 +0100

biometryd (0.3.1-2) unstable; urgency=medium

  * debian/control: Add missing B-D on systemd

 -- Marius Gripsgard <mariogrip@debian.org>  Fri, 02 Feb 2024 02:54:20 +0100

biometryd (0.3.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attribution for debian/.
  * debian/patches:
    + Rebase patches.
  * debian/biometryd-bin.install:
    + Fix path of biometryd.service file.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 01 Feb 2024 18:16:06 +0100

biometryd (0.3.0-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Move files from / to /usr. (Closes: #1052279)

  [ Marius Gripsgard ]
  * debian/control:
    + Add myself (mariogrip) to uploaders

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 19 Sep 2023 21:24:46 +0200

biometryd (0.3.0-3) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/watch: Amend watch URL.

  [ Debian Janitor ]
  * Apply multi-arch hints. + qml-module-biometryd: Add Multi-Arch: same.

  [ Marius Gripsgard ]
  * debian/patches: Add patch to fix FTBFS with gcc 13 (closes #1037592)

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 03:27:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,9 @@
 Source: biometryd
 Priority: optional
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
+           Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: cmake,
                cmake-extras,
                debhelper-compat (= 13),
@@ -26,6 +28,7 @@
                qtdeclarative5-dev,
                qtdeclarative5-dev-tools,
                pkg-kde-tools,
+               systemd-dev [linux-any],
 Standards-Version: 4.6.2
 Section: libs
 Rules-Requires-Root: no
@@ -86,6 +89,7 @@
 Depends: libbiometry1 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
+Multi-Arch: same
 Description: biometryd mediates/multiplexes to biometric devices - QML bindings
  biometryd mediates and multiplexes access to biometric devices present
  on the system, enabling applications and system components to leverage

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/biometryd/-/tags .*/biometryd-(\d\S+)\.tar\.gz

## biometryd 0.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(biometryd)
 
-set(PROJECT_VERSION 0.3.1)
+set(PROJECT_VERSION 0.3.2)
 
 set(BIOMETRYD_VERSION_MAJOR 1)
 set(BIOMETRYD_VERSION_MINOR 0)
@@ -11,7 +11,7 @@
 option(ENABLE_WERROR "Treat all build warnings as errors" ON)
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC -fvisibility=hidden -pthread")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra -fPIC -pthread -DBOOST_ASIO_DISABLE_EPOLL")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra -fPIC -pthread -DBOOST_ASIO_DISABLE_EPOLL")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 
 if(ENABLE_WERROR)
@@ -32,6 +32,7 @@
 
 find_package(PkgConfig)
 find_package(Boost COMPONENTS filesystem program_options system REQUIRED)
+find_package(nlohmann_json 3.11 REQUIRED)
 
 pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
 pkg_check_modules(DBUS dbus-1 REQUIRED)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -7,17 +7,17 @@
 
 install(
   FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.pc
-  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
+  DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
   )
 
 install(
   FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.ubports.biometryd.Service.conf
-  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d/
+  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/dbus-1/system.d/
 )
 
 install(
   FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.conf
-  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/init
+  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/init
 )
 
 if (USE_SYSTEMD)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
     COMMENT "Generating API documentation with Doxygen" VERBATIM)
   install(
     DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
-    DESTINATION ${CMAKE_INSTALL_DOCDIR})
+    DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
 
 endif ()
 endif ()

=== doc/requirements.txt ===
breathe

=== include/CMakeLists.txt ===
add_subdirectory(biometry)

install(
  DIRECTORY biometry
  DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}
  PATTERN "CMakeLists.txt" EXCLUDE
)

=== src/CMakeLists.txt ===
add_subdirectory(biometry)
# add_subdirectory(util)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -78,7 +78,7 @@
 if ("DEB_TARGET_ARCH" STREQUAL "powerpc")
 else()
 add_executable(test_qml_plugin test_qml_plugin.cpp)
-qt5_use_modules(test_qml_plugin Core Qml Quick QuickTest)
+target_link_libraries(test_qml_plugin Qt5::Core Qt5::Qml Qt5::Quick Qt5::QuickTest)
 add_test(test_qml_plugin test_qml_plugin)
 set_tests_properties(test_qml_plugin PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal;QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/src/biometry/qml;BIOMETRYD_QML_ENABLE_TESTING=1")
 file(GLOB BIOMETRYD_QML_TEST_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} tst_*.qml)

=== include/biometry/CMakeLists.txt ===
configure_file(version.h.in version.h)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/version.h
    DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/biometry
)

add_subdirectory(hardware)

=== src/biometry/CMakeLists.txt ===
--- 
+++ 
@@ -157,11 +157,13 @@
   dl
   elf
 
+  nlohmann_json::nlohmann_json
   ${Boost_LIBRARIES}
   ${DBUS_CPP_LIBRARIES}
   ${PROCESS_CPP_LIBRARIES}
   ${SQLITE3_LIBRARIES}
-  ${Hybris})
+  ${Hybris}
+)
 
 add_executable(
   biometryd
@@ -174,10 +176,10 @@
 
 install(
   TARGETS biometry
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
 )
 
 install(
   TARGETS biometryd
-  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+  RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
 )

=== include/biometry/hardware/CMakeLists.txt ===
set(
  BIOMETRY_HARDWARE_HEADERS
  biometry.h
)

install(
  FILES ${BIOMETRY_HARDWARE_HEADERS}
  DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/biometry/hardware
)

=== src/biometry/qml/CMakeLists.txt ===
add_subdirectory(Biometryd)

=== src/biometry/qml/Biometryd/CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
 # can test the module within the build env.
 configure_file(qmldir qmldir COPYONLY)
 
-set(PLUGIN_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/qml/Biometryd)
+set(PLUGIN_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/qt5/qml/Biometryd)
 
 install(
     TARGETS biometryd-qml

=== debian/changelog ===
biometryd (0.3.2-1) unstable; urgency=medium

  * New upstream release.
    - Fix FTBFS against GTest >= 1.17.0. (Closes: #1112727).
  * debian/patches:
    + Drop 0002_data-biometryd.service.in-Let-biometryd.service-repo.patch.
      Applied upstream.
  * debian/libbiometry1.symbols:
    + Drop .symbols file (C++ symbols are not helpful most of the time).
  * debian/{control,rules}:
    + Stop using pkgkde_symbolshelper DH extension, drop pkg-kde-tools from
      B-D: field.
  * debian/control:
    + Add to B-D: field: nlohmann-json3-dev.
  * debian/rules:
    + Drop manual removal of CMakeLists.txt file in <prefix>/include/ path.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 01 Sep 2025 15:31:31 +0200

biometryd (0.3.1-6) unstable; urgency=medium

  * debian/patches:
    + Add 0002_data-biometryd.service.in-Let-biometryd.service-repo.patch.
      On machines without (supported) fingerprint reader hardware, ignore
      biometryd.service startup failures (via exit code 78) and report the
      unit as successfully started to systemd.
  * debian/control:
    + In B-D:, switch from pkg-config to pkgconf.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 12 Jun 2025 13:40:33 +0200

biometryd (0.3.1-5) unstable; urgency=medium

  * debian/control:
    + Versionize B-D on libprocess-cpp-dev. Require process-cpp (>= 3.0.2)
      (which comes with a fixed SOVERSION_MAJOR).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 16 Aug 2024 09:41:19 +0200

biometryd (0.3.1-4) unstable; urgency=medium

  * debian/watch:
    + Update for new GitLab tags page.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 May 2024 10:00:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: biometryd
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
            Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: cmake,
@@ -19,17 +18,17 @@
                libdbus-1-dev,
                libelf-dev,
                libgtest-dev,
-               libprocess-cpp-dev,
+               libprocess-cpp-dev (>= 3.0.2),
                libsqlite3-dev,
                lsb-release,
-               pkg-config,
+               nlohmann-json3-dev,
+               pkgconf,
                qml-module-qttest,
                qtbase5-dev,
                qtdeclarative5-dev,
                qtdeclarative5-dev-tools,
-               pkg-kde-tools,
                systemd-dev [linux-any],
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/biometryd/

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 export XDG_DATA_HOME=/tmp
 
 %:
-	dh $@ --with pkgkde_symbolshelper
+	dh $@
 
 override_dh_missing:
 	dh_missing --fail-missing
@@ -26,10 +26,6 @@
 override_dh_install:
 	# drop upstart configuration
 	rm -Rv debian/tmp/etc/init/
-
-	# Nasty CMakeLists.txt appearing in include directory
-	# See: https://gitlab.com/ubports/development/core/biometryd/-/issues/2
-	rm -v  debian/tmp/usr/include/biometry/CMakeLists.txt
 	dh_install
 
 override_dh_auto_test:
